unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls, system.Math;

type
  TForm1 = class(TForm)
    Image1: TImage;
    FileOpenBtn: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    XshiftEdit: TLabeledEdit;
    YShiftEdit: TLabeledEdit;
    WenlargeEdit: TLabeledEdit;
    HenlargeEdit: TLabeledEdit;
    RotationEdit: TLabeledEdit;
    AffineBtn: TButton;
    vtgEdit: TLabeledEdit;
    htgEdit: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure AffineBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure affine(deg, zx, zy, px, py, vtg, htg: Double);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHW = 512;                              // \TCY

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C
  BlueMat       : array of array of Byte;     // ͉摜pz
  GlueMat       : array of array of Byte;
  RlueMat       : array of array of Byte;

  BOutMat       : array of array of Byte;     // o͉摜pz
  GOutMat       : array of array of Byte;
  ROutMat       : array of array of Byte;
  MatSize       : integer;                    // 摜TCYcő傫̒lgp܂B


//**** affine *** gk,],ړ,fi`Ԗ@j***************
//    *lueMat:    ͉摜z
//    *OutMat:    o͉摜z
//    deg:        ]pixj
//    r           ]piradj
//    zx:            g嗦ij
//    zy:            g嗦icj
//    px:            ړʁij
//    py:            ړʁicj
//    vtg            cf(x)
//    vtr            cf(rad)
//    htg            f(x)
//    htr            f(rad)
//***************************************************************
procedure TForm1.affine(deg, zx, zy, px, py, vtg, htg: Double);
var
  i, j, m, n        :   Integer;
  x, y, u, v, p, q  :   Double;
  r, c, s           :   Double;
  xs, ys, xsp, ysp  :   Integer;
  db, dg, dr        :   Integer;
  vtr, htr          :   double;
begin
  r   := DegToRad(deg);                   // ]p
  vtr := tan(DegToRad(vtg));              // cfp
  htr := tan(DegToRad(htg));              // fp
  c := cos(r);
  s := sin(r);
  ys := MatSize div 2;                    // cSʒuvZ
  xs := MatSize div 2;                    // SʒuvZ
  ysp := ys - 1;                          // ysől  (m + ys) < GHeight
  xsp := xs - 1;                          // xsől  (n + xs) < GWidth
  if MatSize mod 2 <> 0 then begin        // TCY̏ꍇ͂P傫
    ysp := ys;
    xsp := xs;
  end;
  for i := -ys to ysp - 1 do              // o̓rbg}bvc͈
    for j := -xs to xsp - 1 do begin      // o̓rbg}bv͈
      v := i + py;                        // cVtg
      u := j - px;                        // Vtg
      y := (u * s + v * c) / zy;          // cϔ{
      x := (u * c - v * s) / zx;          // ϔ{
      y := y + x * vtr;                   // cf
      x := x - y * htr;                   // f
      m := floor(y);                      // ւ܂  ւ܂߂ȂƐԒlɂȂ܂
      n := floor(x);                      // ւ܂
      q := y - m;                         // x␳l _ȉ̒l߂܂
      p := x - n;                         // w␳l
      m := m + ys;                        // }WY
      n := n + xs;                        // }WX
      // `ԌvZ
      if (m >= 0) and (m < ysp + ys) and (n >= 0) and (n < xsp + xs) then begin
        db := trunc(((1 - q) * ((1 - p) * BlueMat[m    , n    ]
                                    + P * BlueMat[m    , n + 1])
                         + q * ((1 - p) * BlueMat[m + 1, n    ]
                                    + P * BlueMat[m + 1, n + 1])));
        dg := trunc(((1 - q) * ((1 - p) * GlueMat[m    , n    ]
                                    + P * GlueMat[m    , n + 1])
                         + q * ((1 - p) * GlueMat[m + 1, n    ]
                                    + P * GlueMat[m + 1, n + 1])));
        dr := trunc(((1 - q) * ((1 - p) * RlueMat[m    , n    ]
                                    + P * RlueMat[m    , n + 1])
                         + q * ((1 - p) * RlueMat[m + 1, n    ]
                                    + P * RlueMat[m + 1, n + 1])));
      end
      else begin                          // 摜͈͊O͍
        db := 0;
        dg := 0;
        dr := 0;
      end;
      BOutMat[i + ys,J + xs] := db;       // o͗pzɕۑ
      GOutMat[i + ys,J + xs] := dg;
      ROutMat[i + ys,J + xs] := dr;
    end;
end;

//***************************************************
// AtBݒl`FbN
// ͐leLXglϊ
// AtBϊ摜\
//***************************************************
procedure TForm1.AffineBtnClick(Sender: TObject);
var
  deg   : Double;     // ]pixj
  zx    : Double;     // g嗦ij
  zy    : Double;     // g嗦icj
  px    : Double;     // ړʁij
  py    : Double;     // ړʁicj
  vtg   : Double;     // ficj
  htg   : Double;     // fij

  ch    : Integer;
  XX, YY: Integer;
  PD    : PBytearray;
  PW    : Integer;
begin
  val(RotationEdit.Text, deg, ch);
  if ch <> 0 then begin
    application.MessageBox(']pɌ肪܂', '', 0);
    exit;
  end;
  val(XshiftEdit.Text, px, ch);
  if ch <> 0 then begin
    application.MessageBox('wړʂɌ肪܂', '', 0);
    exit;
  end;
  val(YshiftEdit.Text, py, ch);
  if ch <> 0 then begin
    application.MessageBox('xړʂɌ肪܂', '', 0);
    exit;
  end;
  val(WenlargeEdit.Text, zx, ch);
  if ch <> 0 then begin
    application.MessageBox('{Ɍ肪܂', '', 0);
    exit;
  end;
  if zx = 0 then begin
    application.MessageBox('{̓[ł͂܂', '', 0);
    exit;
  end;
  val(HenlargeEdit.Text, zy, ch);
  if ch <> 0 then begin
    application.MessageBox('c{Ɍ肪܂', '', 0);
    exit;
  end;
  if zy = 0 then begin
    application.MessageBox('c{̓[ł͂܂', '', 0);
    exit;
  end;
  val(htgEdit.Text, htg, ch);
  if ch <> 0 then begin
    application.MessageBox('fpɌ肪܂', '', 0);
    exit;
  end;
  if (htg >= 90) or (htg <= -90) then begin
    application.MessageBox('pxXO  XOzĂ͂܂', '', 0);
    exit;
  end;
  val(vtgEdit.Text, vtg, ch);
  if ch <> 0 then begin
    application.MessageBox('cfpɌ肪܂', '', 0);
    exit;
  end;
  if (vtg >= 90) or (vtg <= -90) then begin
    application.MessageBox('pxXO  XOzĂ͂܂', '', 0);
    exit;
  end;
  affine(deg, zx, zy, px, py, vtg, htg);    // affineϊ
  OutputBitmap.PixelFormat := pf24bit;      // 24rbgtH[}bgݒ
  OutputBitmap.Width := MatSize;            // rbg}bvTCYݒ
  OutputBitmap.Height:= MatSize;
  for YY := 0 to MatSize - 1 do begin       // z̃f[^[rbg}bvɃRs[
    PD := OutputBitmap.ScanLine[YY];
    for XX := 0 to MatSize - 1 do begin
      PW := XX * 3;
      PD[PW    ] := BOutMat[YY, XX];
      PD[PW + 1] := GOutMat[YY, XX];
      PD[PW + 2] := ROutMat[YY, XX];
    end;
  end;
  Image1.Canvas.StretchDraw(VRect, OutputBitmap);   // o͘gɕϔ{o
end;

//*************************************************************
// t@C̃I[v
// rbg}bvƗpzɕϊ@Jt@C̉摜\
//*************************************************************
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  IHeight     : Integer;
  IWidth      : Integer;
  PBA         : PByteArray;
  HH, WW      : Integer;
  PosP        : Integer;
begin
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InputDBitmap.Assign(WIC);                             // Tbitmap  TWICImageRs[
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end
    else exit;
  // ͉摜f[^[pzm
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  MatSize := GHeight;
  if GHeight < GWidth then MatSize := GWidth;
  // zm
  SetLength(BlueMat, MatSize, MatSize);
  SetLength(GlueMat, MatSize, MatSize);
  SetLength(RlueMat, MatSize, MatSize);
  SetLength(BOutMat, MatSize, MatSize);
  SetLength(GOutMat, MatSize, MatSize);
  SetLength(ROutMat, MatSize, MatSize);

  for HH := 0 to MatSize - 1 do                               // z񏉊
    for WW := 0 to MatSize - 1 do begin
      BlueMat[HH, WW] := 0;
      GlueMat[HH, WW] := 0;
      RlueMat[HH, WW] := 0;
    end;

  // 摜SʒuݒpVtglvZ
  IHeight := 0;
  IWidth  := 0;
  if GHeight <= GWidth then                                   // cɂVtgݒ 摜𒆐SʒuɃZbg܂
    IHeight := (GWidth - GHeight) div 2
  else
    IWidth := (GHeight - IHeight) div 2;

  // ͉摜zɕۑ
  for HH := 0 to GHeight - 1 do begin
    PBA := InputDBitmap.ScanLine[HH];
    for WW := 0 to GWidth - 1 do begin
      PosP := WW * 4;
      BlueMat[HH + IHeight, WW + IWidth] := PBA[PosP];
      GlueMat[HH + IHeight, WW + IWidth] := PBA[PosP + 1];
      RlueMat[HH + IHeight, WW + IWidth] := PBA[PosP + 2];
    end;
  end;
  // ͉摜\
  InputDBitmap.Assign(nil);
  InputDBitmap.PixelFormat := pf24bit;
  InputDBitmap.Width := MatSize;
  InputDBitmap.Height := MatSize;
  for HH := 0 to MatSize - 1 do begin
    PBA := InputDBitmap.ScanLine[HH];
    for WW := 0 to MatSize - 1 do begin
      PosP := WW * 3;
      PBA[PosP]     := BlueMat[HH, WW];
      PBA[PosP + 1] := GlueMat[HH, WW];
      PBA[PosP + 2] := RlueMat[HH, WW];
    end;
  end;
  VRect := rect(0, 0, ImageHW, ImageHW);
  Image1.Canvas.StretchDraw(VRect, InputDBitmap);   // o͘gɕϔ{o
  AffineBtn.Enabled := True;
end;

//**********************************************
// N̐ݒ
//**********************************************
procedure TForm1.FormCreate(Sender: TObject);
var
  ABitmap : TBitmap;
begin
  Top  := (Screen.Height - Height) div 2;
  Left := (Screen.Width  - Width)  div 2;
  Image1.Height := 512;
  Image1.Width  := 512;
  // ͂̕ȂĂɖȂ
  ABitmap := TBitmap.Create;
  try
    ABitmap.Width   := Image1.Width;
    ABitmap.Height  := Image1.Height;
    Image1.Picture.Graphic := ABitmap;    // GraphicBitmap̊t
  finally
    ABitmap.Free;
  end;
  // ܂
  InputDBitmap := Tbitmap.Create;
  OutputBitmap := Tbitmap.Create;
  AffineBtn.Enabled := False;
end;

//*********************************************
// Irbg}bv̉
//*********************************************
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;

end.
